"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var directory_tree_1 = __importDefault(require("directory-tree"));
var node_emoji_1 = require("node-emoji");
var pdf_from_html_1 = __importDefault(require("pdf-from-html"));
var solidity_1 = require("./solidity");
var highlight_js_1 = require("highlight.js");
var markdown_it_emoji_1 = __importDefault(require("markdown-it-emoji"));
var mustache_1 = require("mustache");
var tests_1 = require("./tests");
// eslint-disable-next-line @typescript-eslint/no-var-requires
var md = require('markdown-it')({
    highlight: function (str, lang) {
        if (lang && highlight_js_1.getLanguage(lang)) {
            try {
                return "<pre class=\"hljs\"><code>" + highlight_js_1.highlight(lang, str, true).value + "</code></pre>";
                // eslint-disable-next-line no-empty
            }
            catch (__) { }
        }
        return "<pre class=\"hljs\"><code>" + md.utils.escapeHtml(str) + "</code></pre>";
    },
    html: true,
    linkify: true,
    typographer: true,
});
md.use(markdown_it_emoji_1.default);
md.renderer.rules.emoji = function (token, idx) { return "<i class=\"twa twa-" + token[idx].markup + "\"></i>"; };
/**
 * TODO: to write!
 */
var Generate = /** @class */ (function () {
    /**
     * TODO: to write!
     */
    function Generate(files, exclude, inputPath, outputPath, testsPath, testsExtension, baseLocation) {
        var _this = this;
        this.lineBreak = '\r\n';
        this.htmlDefaultTemplatePath = 'dist/template/html/index.html';
        this.pdfDefaultTemplatePath = 'dist/template/pdf/index.html';
        this.docsifyDefaultHTMLTemplatePath = 'template/docsify/index.html';
        this.contracts = [];
        var testComments = tests_1.parseTestsComments(testsPath, testsExtension);
        files.forEach(function (file) { return _this.contracts.push(solidity_1.parseSingleSolidityFile(file, testComments, baseLocation)); });
        this.outputPath = outputPath;
        this.inputPathStructure = directory_tree_1.default(inputPath, { exclude: exclude.map(function (i) { return new RegExp(i); }) });
        this.hasLICENSE = fs_1.default.existsSync(path_1.default.join(process.cwd(), 'LICENSE'));
    }
    /**
     * TODO: to write!
     */
    Generate.prototype.gitbook = function () {
        this.renderContracts();
        // generate summary file (essential in gitbook)
        var SUMMARYContent = "# Summary\r\n* WELCOME" + this.lineBreak;
        SUMMARYContent = this.renderDocumentationIndex(SUMMARYContent);
        // create summary file
        fs_1.default.writeFileSync(path_1.default.join(process.cwd(), this.outputPath, 'SUMMARY.md'), SUMMARYContent);
        this.renderReadme(true);
    };
    /**
     * TODO: to write!
     */
    Generate.prototype.docsify = function () {
        this.renderContracts();
        // generate _sidebar file (essential in docsify, to have a custom sidebar)
        var SIDEBARContent = "* WELCOME" + this.lineBreak + "\t* [Home](/)" + this.lineBreak;
        SIDEBARContent = this.renderDocumentationIndex(SIDEBARContent);
        // create _sidebar file
        fs_1.default.writeFileSync(path_1.default.join(process.cwd(), this.outputPath, '_sidebar.md'), SIDEBARContent);
        this.renderReadme(true);
        // copy html base
        fs_1.default.copyFileSync(path_1.default.join(__dirname, this.docsifyDefaultHTMLTemplatePath), path_1.default.join(process.cwd(), this.outputPath, 'index.html'));
        // write nojekill
        fs_1.default.writeFileSync(path_1.default.join(process.cwd(), this.outputPath, '.nojekill'), ' ');
    };
    /**
     * TODO: to write!
     */
    Generate.prototype.html = function () {
        var _this = this;
        this.contracts.forEach(function (contract) {
            var HTMLContent = _this.mustacheRender(path_1.default.join(contract.folder, _this.htmlDefaultTemplatePath), contract);
            HTMLContent = _this.fixUrls(HTMLContent);
            fs_1.default.writeFileSync(path_1.default.join(process.cwd(), _this.outputPath, contract.filename + ".html"), _this.applyEmojify(HTMLContent));
        });
        this.renderReadme(false);
        // if there's a LICENSE
        if (this.hasLICENSE) {
            var templateContent = String(fs_1.default.readFileSync(path_1.default.join(this.contracts[0].folder, this.htmlDefaultTemplatePath)));
            var LICENSEText = String(fs_1.default.readFileSync(path_1.default.join(process.cwd(), 'LICENSE'))).trim();
            var LICENSE = LICENSEText.replace(/\n/g, '<br>');
            var projectName = JSON.parse(String(fs_1.default.readFileSync(path_1.default.join(process.cwd(), 'package.json')))).name;
            var view = {
                LICENSE: LICENSE,
                contractsStructure: this.contracts,
                folderStructure: JSON.stringify(this.inputPathStructure),
                hasLICENSE: true,
                projectName: projectName,
            };
            var outputLicense = mustache_1.render(templateContent, view);
            fs_1.default.writeFileSync(path_1.default.join(process.cwd(), this.outputPath, 'license.html'), outputLicense);
        }
        return 0;
    };
    /**
     * TODO: to write!
     */
    Generate.prototype.pdf = function () {
        return __awaiter(this, void 0, void 0, function () {
            var totalContracts, c, HTMLContent;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        totalContracts = this.contracts.length;
                        c = 0;
                        _a.label = 1;
                    case 1:
                        if (!(c < totalContracts)) return [3 /*break*/, 4];
                        HTMLContent = this.mustacheRender(path_1.default.join(this.contracts[c].folder, this.pdfDefaultTemplatePath), this.contracts[c]);
                        HTMLContent = this.fixUrls(HTMLContent);
                        return [4 /*yield*/, pdf_from_html_1.default.generatePDF(this.outputPath, this.contracts[c].filename, this.applyEmojify(HTMLContent))];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        c += 1;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * TODO: to write!
     */
    Generate.prototype.renderContracts = function () {
        var _this = this;
        this.contracts.forEach(function (contract) {
            // transform the template
            var MDContent = "# " + contract.name + _this.lineBreak;
            if (contract.data.contract !== undefined) {
                if (contract.data.contract.natspec.dev) {
                    MDContent += "*" + contract.data.contract.natspec.dev + "*" + _this.lineBreak;
                }
                if (contract.data.contract.natspec.notice) {
                    MDContent += "" + contract.data.contract.natspec.notice + _this.lineBreak;
                }
            }
            contract.data.functions.forEach(function (f) {
                MDContent += "## " + f.ast.name + _this.lineBreak + _this.lineBreak;
                if (f.ast.natspec === null) {
                    return;
                }
                if (f.ast.natspec.dev) {
                    MDContent += "*" + f.ast.natspec.dev + "*" + _this.lineBreak + _this.lineBreak;
                }
                if (f.ast.natspec.notice) {
                    MDContent += "" + f.ast.natspec.notice + _this.lineBreak + _this.lineBreak;
                }
                var table = false;
                if (f.parameters.length > 0) {
                    table = true;
                    MDContent += _this.lineBreak + "|Input/Output|Data Type|Variable Name|Comment|" + _this.lineBreak
                        + ("|----------|----------|----------|----------|" + _this.lineBreak);
                    f.parameters.forEach(function (p) {
                        MDContent += "|input|" + p.typeName.name + "|" + p.name + "|" + p.natspec + "|" + _this.lineBreak;
                    });
                }
                if (f.returnParameters !== null && f.returnParameters.length > 0) {
                    if (!table) {
                        MDContent += _this.lineBreak + "|Input/Output|Data Type|Variable Name|Comment|" + _this.lineBreak
                            + ("|----------|----------|----------|----------|" + _this.lineBreak);
                    }
                    f.returnParameters.forEach(function (p) {
                        MDContent += "|output|" + p.typeName.name + "|" + ((p.name === null) ? ('N/A') : (p.name)) + "|"
                            + (((p.natspec === undefined) ? ('N/A') : (p.natspec)) + "|" + _this.lineBreak);
                    });
                }
                MDContent += _this.lineBreak;
            });
            // write it to a file
            fs_1.default.writeFileSync(path_1.default.join(process.cwd(), _this.outputPath, contract.filename + ".md"), MDContent);
        });
    };
    /**
     * TODO: to write!
     */
    Generate.prototype.renderReadme = function (original) {
        var _this = this;
        var outputReadme = '# Hello';
        if (fs_1.default.existsSync(path_1.default.join(process.cwd(), 'README.md'))) {
            outputReadme = fs_1.default.readFileSync(path_1.default.join(process.cwd(), 'README.md')).toString();
        }
        if (original) {
            fs_1.default.writeFileSync(path_1.default.join(process.cwd(), this.outputPath, 'README.md'), outputReadme);
        }
        else {
            var templateContent = String(fs_1.default.readFileSync(path_1.default.join(this.contracts[0].folder, this.htmlDefaultTemplatePath)));
            var pureREADME = String(fs_1.default.readFileSync(path_1.default.join(process.cwd(), 'README.md'))).trim();
            var projectName = JSON.parse(String(fs_1.default.readFileSync(path_1.default.join(process.cwd(), 'package.json')))).name;
            var view = {
                README: md.render(pureREADME),
                contractsStructure: this.contracts,
                folderStructure: JSON.stringify(this.inputPathStructure),
                hasLICENSE: this.hasLICENSE,
                projectName: projectName,
            };
            outputReadme = mustache_1.render(templateContent, view);
            fs_1.default.writeFileSync(path_1.default.join(process.cwd(), this.outputPath, 'index.html'), outputReadme);
        }
        // if there's an image reference in readme, copy it
        var files = [];
        var filesList = fs_1.default.readdirSync(process.cwd());
        filesList.forEach(function (file) {
            var stats = fs_1.default.lstatSync(path_1.default.join(process.cwd(), file));
            if (stats.isFile() && (path_1.default.extname(file) === '.png' || path_1.default.extname(file) === '.jpg')) {
                files.push(file);
            }
        });
        // and if the file is a readme, copy it
        files.forEach(function (file) {
            if (outputReadme.includes(file)) {
                fs_1.default.copyFileSync(path_1.default.join(process.cwd(), file), path_1.default.join(process.cwd(), _this.outputPath, file));
            }
        });
    };
    /**
     * TODO: to write!
     */
    Generate.prototype.renderDocumentationIndex = function (content) {
        var _this = this;
        var documentationIndexContent = content;
        if (this.hasLICENSE) {
            documentationIndexContent += "\t* [LICENSE](LICENSE.md)" + this.lineBreak;
            fs_1.default.copyFileSync(path_1.default.join(process.cwd(), 'LICENSE'), path_1.default.join(process.cwd(), this.outputPath, 'LICENSE.md'));
        }
        documentationIndexContent += "* CONTRACTS" + this.lineBreak;
        this.contracts.forEach(function (s) {
            documentationIndexContent += "\t* [" + s.name + "](" + s.name + ".md)" + _this.lineBreak;
        });
        return documentationIndexContent;
    };
    /**
     * Using the given parameters, calls the Mustache engine
     * and renders the HTML page.
     * @param {string} templateFilePath Path for template file
     * @param {string} contract contract object
     */
    Generate.prototype.mustacheRender = function (templateFilePath, contract) {
        var templateContent = String(fs_1.default.readFileSync(templateFilePath));
        var projectName = JSON.parse(String(fs_1.default.readFileSync(path_1.default.join(process.cwd(), 'package.json')))).name;
        var view = {
            contract: contract,
            contracts: this.contracts,
            currentDate: new Date().getTime(),
            folderStructure: JSON.stringify(this.inputPathStructure),
            hasLICENSE: this.hasLICENSE,
            projectName: projectName,
        };
        var output = mustache_1.render(templateContent, view);
        return output;
    };
    Generate.prototype.fixUrls = function (content) {
        var match = content.match(/(?<!\[)https?:&#x2F;&#x2F;[a-zA-Z0-9.&#x2F;\-_]+/g);
        if (match !== null) {
            var transform = match.map(function (url) { return url.replace(/&#x2F;/g, '/'); });
            transform = transform.map(function (url) { return "<a href=\"" + url + "\">" + url + "</a>"; });
            for (var i = 0; i < match.length; i += 1) {
                content = content.replace(match[i], transform[i]);
            }
        }
        return content;
    };
    ;
    Generate.prototype.applyEmojify = function (content) {
        var formatEmojify = function (code, name) { return "<i alt=\"" + code + "\" class=\"twa twa-" + name + "\"></i>"; };
        return node_emoji_1.emojify(content, null, formatEmojify);
    };
    ;
    return Generate;
}());
exports.Generate = Generate;
//# sourceMappingURL=generate.js.map