"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var typescript_estree_1 = require("@typescript-eslint/typescript-estree");
// thanks to Netsi1964 @ https://stackoverflow.com/a/52024318/3348623
function getFilesFromPath(folderPath, extension) {
    var dir = fs_1.default.readdirSync(folderPath);
    var re = new RegExp(extension);
    return dir.filter(function (elm) { return re.exec(elm); });
}
/**
 * TODO:
 */
function parseTestsComments(testsPath, testsExtension) {
    var testFiles = getFilesFromPath(testsPath, testsExtension);
    var result = new Map();
    testFiles.forEach(function (file) {
        var filePath = path_1.default.join(process.cwd(), testsPath, file);
        var code = fs_1.default.readFileSync(filePath).toString();
        var ast = typescript_estree_1.parse(code, {
            comment: true,
            loc: true,
            range: true,
        });
        ast.comments.forEach(function (comment) {
            var query = /@test {([\w#]+)}/ig.exec(comment.value);
            if (query !== null && query !== undefined) {
                var content = query[1];
                if (content !== null && content !== undefined) {
                    var contentHashtag = content.indexOf('#');
                    var contractName = content.substr(0, contentHashtag > 0 ? contentHashtag : content.length);
                    var commentMap = result.get(contractName);
                    if (commentMap === null || commentMap === undefined) {
                        commentMap = [];
                    }
                    if (contentHashtag > 0) {
                        commentMap.push({
                            filePath: path_1.default.join(testsPath, file),
                            loc: comment.loc,
                            name: content.substr(contentHashtag + 1, content.length),
                        });
                    }
                    else {
                        commentMap.push({
                            filePath: path_1.default.join(testsPath, file),
                            loc: comment.loc,
                            name: '#',
                        });
                    }
                    result.set(contractName, commentMap);
                }
            }
        });
    });
    return result;
}
exports.parseTestsComments = parseTestsComments;
//# sourceMappingURL=tests.js.map